"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transpileTS = exports.transformTsx = void 0;
const esbuild_1 = require("esbuild");
const console_1 = require("../../console");
const fsAddons_1 = require("../../fsAddons");
const paths_1 = require("../../paths");
const fs_1 = __importDefault(require("fs"));
const transformTsx = (config) => (tsFiles) => __awaiter(void 0, void 0, void 0, function* () {
    const tsconfig = JSON.parse(fs_1.default.readFileSync('./tsconfig.json').toString('utf-8'));
    try {
        return Promise.all(tsFiles.map((tsFile) => __awaiter(void 0, void 0, void 0, function* () {
            const transpiled = yield (0, exports.transpileTS)(fs_1.default.readFileSync((0, paths_1.pathIn)(config)(tsFile)).toString('utf-8'), tsFile.endsWith('tsx') ? 'tsx' : 'ts', tsconfig);
            const newJsFile = tsFile.replace(/\.tsx?$/, '.js');
            const jsFileName = (0, paths_1.pathIn)(config)(newJsFile);
            (0, fsAddons_1.fileWriteRecuirsiveSync)(jsFileName, transpiled.code);
            return newJsFile;
        })));
    }
    catch (error) {
        if (error instanceof Error) {
            (0, console_1.message)(error.message, 'red');
        }
        return;
    }
});
exports.transformTsx = transformTsx;
const transpileTS = (code, loader, options) => {
    return (0, esbuild_1.transform)(code, {
        tsconfigRaw: JSON.stringify(options),
        loader,
        format: 'esm',
    });
};
exports.transpileTS = transpileTS;
//# sourceMappingURL=tsx.js.map